//+------------------------------------------------------------------+
//|                                            MTF_MovingAverage.mq4 |
//|                                      Copyright  2006, Keris2112 |
//|                                                                  |
//+------------------------------------------------------------------+
//mod2009fxtsd   +hrzline

#property copyright "Copyright  2006, Keris2112"
#property link      "http://www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Blue
#property indicator_width1 2

//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
---------------------------------------
PRICE_CLOSE    0 Close price. 
PRICE_OPEN     1 Open price. 
PRICE_HIGH     2 High price. 
PRICE_LOW      3 Low price. 
PRICE_MEDIAN   4 Median price, (high+low)/2. 
PRICE_TYPICAL  5 Typical price, (high+low+close)/3. 
PRICE_WEIGHTED 6 Weighted close price, (high+low+close+close)/4. 
You must use the numeric value of the Applied Price that you want to use
when you set the 'applied_price' value with the indicator inputs.
---------------------------------------
MODE_SMA    0 Simple moving average, 
MODE_EMA    1 Exponential moving average, 
MODE_SMMA   2 Smoothed moving average, 
MODE_LWMA   3 Linear weighted moving average. 
You must use the numeric value of the MA Method that you want to use
when you set the 'ma_method' value with the indicator inputs.

**************************************************************************/
extern int TimeFrame=0;
extern int MAPeriod=21;
extern int ma_shift=0;
extern int ma_method=1;
extern int applied_price=0;

extern bool    DrawMALine =true;
extern bool    DrawHrzLine=true;
extern color   HrzLineColor=DodgerBlue;
extern int     HrzLineStyle=2;
extern int     HrzLineWidth=1;
extern int     HrzLineOnBar=0;
extern bool    HrzLineOnBackground=true;

extern string   note_Price = "0C 1O 2H 3L 4Md 5Tp 6WghC: Md(HL/2)4,Tp(HLC/3)5,Wgh(HLCC/4)6";
extern string   _MA_Method = "SMA0 EMA1 SMMA2 LWMA3";
extern string TimeFrames = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN";

string short_name;
string shortname;   


double ExtMapBuffer1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//   string short_name;
//---- indicator line
   SetIndexBuffer(0,ExtMapBuffer1);

   if (DrawMALine)
   SetIndexStyle(0,DRAW_LINE);
   else 
   SetIndexStyle(0,DRAW_NONE);

   if(TimeFrame==0) TimeFrame = Period();
   SetIndexShift(0,ma_shift*TimeFrame/Period());
//---- name for DataWindow and indicator subwindow label   
   switch(ma_method)
     {
      case 1 : short_name="MTF_EMA("; break;
      case 2 : short_name="MTF_SMMA("; break;
      case 3 : short_name="MTF_LWMA("; break;
      default : short_name="MTF_SMA(";
     }
   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="M1"; break;
      case 5 : TimeFrameStr="M5"; break;
      case 15 : TimeFrameStr="M15"; break;
      case 30 : TimeFrameStr="M30"; break;
      case 60 : TimeFrameStr="H1"; break;
      case 240 : TimeFrameStr="H4"; break;
      case 1440 : TimeFrameStr="D1"; break;
      case 10080 : TimeFrameStr="W1"; break;
      case 43200 : TimeFrameStr="MN1"; break;
      default : TimeFrameStr="TF0";
   } 
   TimeFrame = MathMax(TimeFrame, Period());
   
   shortname= short_name +MAPeriod+") TF"+TimeFrame;  
   IndicatorShortName (shortname);


  return(0);
  }

//----
  int deinit()
{
  
   ObjectDelete(shortname);

   return(0);
}

 
//+------------------------------------------------------------------+
//| MTF Moving Average                                  
//+------------------------------------------------------------------+

int start()
  {
   datetime TimeArray[];
   int    i,y,limit,counted_bars=IndicatorCounted();
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;

   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit=Bars-counted_bars;
   limit=MathMax(limit,TimeFrame/Period());

   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<iTime(NULL,TimeFrame,y)) y++; 
   
    
   ExtMapBuffer1[i]=iMA(NULL,TimeFrame,MAPeriod,0,ma_method,applied_price,y) ; 
 
     
//
   if (DrawHrzLine)   
   if   (ObjectFind(shortname)==-1) CreateLine();
         ObjectSet (shortname,OBJPROP_TIME1,Time[0]);
         ObjectSet (shortname,OBJPROP_PRICE1,ExtMapBuffer1[0]);
     
  }
  
   return(0);
 }
//+------------------------------------------------------------------+


  void CreateLine()
{
 SetIndexBuffer(0,ExtMapBuffer1);
 ObjectCreate  (shortname,OBJ_HLINE,0,0,0,0,0);
 ObjectSet     (shortname,OBJPROP_COLOR,HrzLineColor);
 ObjectSet     (shortname,OBJPROP_WIDTH,HrzLineWidth);
 ObjectSet     (shortname,OBJPROP_STYLE,HrzLineStyle);
 ObjectSet     (shortname,OBJPROP_BACK, HrzLineOnBackground);
}

